<template>
  <div class="container mt-5">

    <button class="btn btn-danger" style="height: 40px">
            <router-link class="nav-link" style="color:white; margin-top: -10px" to="/clienteedit">editar perfil</router-link>
    </button>
    <h2>Verifique status do seu chamado</h2>
   

    <table class="table table-striped mt-5">
      <thead>
        <tr>
          <th>ID</th>
          <th>Defeito Apresentado</th>
          <th>Defeito Relatado</th>
          <th>Valor</th>
          <th>Status</th>
          <th>garantia</th>

        </tr>
      </thead>

      <tbody>
        <tr v-for="chamado in chamados" v-bind:key="chamado.id">
          <td>{{ chamado.id }}</td>
          <td>{{ chamado.defApresentado }}</td>
          <td>{{ chamado.defRelatado }}</td>
          <td>{{ chamado.valor }}</td>
          <td>{{ convertStatus(chamado.status) }}</td>
          <td>{{ chamado.dataWaranty}}</td>
          <td>
            <a
              data-toggle="collapse"
              href="'#' + chamado.id"
              class="btn btn-sm btn-success mx-1"
              @click="aprovar(chamado.id, chamado.status)"
            >
              <i class="far fa-thumbs-up" title="Aprovar"></i>
            </a>
            <a
              data-toggle="collapse"
              href="'#' + chamado.id"
              class="btn btn-sm btn-danger mx-1"
              @click="reprovar(chamado.id, chamado.status)"
              
            >
              <i class="far fa-thumbs-down" title="reprovar"></i>
            </a>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import axios from "axios";

export default {
  data() {
    return {
    
      chamados: null,
      chamado: {
        status: null,
      },
    };
  },
    props: {
    user: String,
  },
  methods: {
        convertStatus(status) {
      let statusString;
      switch (parseInt(status)) {
        case 1:
          statusString = "Criado";
          break;
        case 2:
          statusString = "Em bancada";
          break;
        case 3:
          statusString = "Orçamento Enviado";
          break;
        case 4:
          statusString = "Orçamento Aprovado";
          break;
        case 5:
          statusString = "Orçamento Reprovado";
          break;
        case 6:
          statusString = "Não Aprovado, aguardando retirada";
          break;
        case 7:
          statusString = "Aprovado, aguardando retirada";
          break;
        case 8:
          statusString = "Aprovado, retirado";
          break;
        case 9:
          statusString = "Não Aprovado, retirado";
          break;
        case 10:
          statusString = "Pago, Aguardando retirada";
          break;
        default:
          statusString = "desconhecido";
      }
      return statusString;
    },
    aprovar(id, status){
      if(status == 4 || status == 5 || status ==3){
            this.chamado.status = 4
            this.salvar(id)
      }
      else{
        alert("Não é possivel alterar, verifique o status se ja foi feito o reparo ou se ja foi retirado")
      }
    },
    reprovar(id, status){ 
      if(status == 4 || status == 5 || status ==3){
        this.chamado.status = 5
        this.salvar(id)
      }
      else{
        alert("Não é possivel alterar, verifique o status se ja foi feito o reparo se ou ja foi retirado")
      }
    },
    listar() {
      axios
        .get(this.$MainURL + "/homeClientes", {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`
              }
          })
        .then((response) => (this.chamados = response.data));
    },
    buscar(nome) {
      if (!nome) {
        this.listar();
      } else {
        axios
          .get(this.$MainURL + "/chamados/" + nome, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`
              }
          })
          .then((response) => (this.chamados = response.data));
      }
    },
    salvar(id) {

        axios
          .put(this.$MainURL + "/homeCliente/" + id, this.chamado, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`
              }
          })
          // eslint-disable-next-line no-unused-vars
          .then((response) => {
            alert(`Ok, Alterado com sucesso`);
            this.listar();
            this.chamado = {};
          });
    
    },
    editar(id) {
      axios
        .get(this.$MainURL + "/chamados/" + id, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`
              }
          })
        .then((response) => (this.chamado = response.data));
      this.$refs.nome.focus();
    },
    excluir(id, cod) {
      if (confirm(`Confirma exclusão do filme '${cod}`));

      axios
        .delete(this.$MainURL + "/chamados/" + id, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`
              }
          })
        // eslint-disable-next-line no-unused-vars
        .then((response) => {
          alert(`chamado '${cod}' excluido com sucesso`);
          this.listar();
        });
    },
  },
  mounted() {
    this.listar();
  },
};
</script>

<style scoped>
</style>